import std/[httpclient, strutils, strformat]
import niup

var textLabel: Text_T  # global, so it can be accessed from callbacksi, init later, after IUP Open()

# Create an exit button proc
proc button_exit_callback(ih: PIhandle):cint {.cdecl} =
  # exists the main loop
   return IUP_CLOSE


const src = "https://icanhazip.com"
proc Ip*(): string =
   var client = newHttpClient()
   try:
     let response = client.getContent(src)
     result = response.strip()
   except:
     let
       e = getCurrentException()
       msg = getCurrentExceptionMsg()
     echo "Got exception ", repr(e), " with message ", msg
     result = ""
   finally:
     client.close()
   return result # there was recursive call to Ip()


proc button_show_ip(ih: PIhandle): cint {.cdecl.} = # every callback has cint as return value
  textLabel.value = Ip()
  return IUP_DEFAULT

# create main proc and open UIP application
proc mainProc =
  Open()

# create 3 variables (label, button, vbox)
 # var 
 #   label = Label("Hello, IUP from nim.")
 #   button = Button("Hit me to close")
 #   vbox = Vbox(label, button) # add button and label to vertical box 
 # # add attributes to variables 
 # vbox.alignment = IUP_ACENTER
 # vbox.gap(10)
 # vbox.margin(30, 60)


  textLabel = Text("IP address")  # declared globally so it can be accessed from callback
  textLabel.readonly = true

  var
    button_h = Button("Show Ip Address")
    #textLabel_output = Label(Ip)
    hbox = Hbox(textLabel, button_h)
# add dialog box to show title of UIP application

  hbox.alignment = IUP_ACENTER
  hbox.gap(20)
  hbox.margin(20, 70)

  var dlg_h = Dialog(hbox)

  dlg_h.title = "Hello horizonal window"
  #button_h.action = button_show_ip
  opacity(dlg_h,  115) # horizonal box now has opacity

# call backs 
  button_h.action = button_exit_callback
  button_h.action = button_show_ip

# show UIP application
  #ShowXY(dlg, IUP_CENTER, IUP_CENTER)
  ShowXY(dlg_h , IUP_CENTER, IUP_CENTER)

  MainLoop()
  Close()

if isMainModule: # if main module than call mainProc()
  mainProc()

